var tvKey     = new Common.API.TVKeyValue();
var widgetAPI = new Common.API.Widget();
var fs        = new FileSystem();
var pluginAPI; 

var API_Net;
var API_NNAVI;

var g_CONFIG    = {};

function insertHTML(itemID, cont)
{
	var item = document.getElementById(itemID);
	widgetAPI.putInnerHTML(item, cont);
}

function funcWithContext(context, func)
{
	return function(){func.call(context)};
}

AppManager = {};

AppManager.currentController = null;

AppManager.setScene = function(controller, params) 
{
	if (this.currentController)
		this.currentController.onUnSet();
	$('#listener').unbind('keydown', false);
	
	this.currentController = controller;
	
	controller.onSet(params);
	
	var handler = funcWithContext(controller, controller.onKeyDown);
	$('#listener').keydown(handler);
};


AppManager.onload = function()
{	
	API_Net   = document.getElementById('pluginObjectNETWORK');
	API_NNAVI = document.getElementById('pluginObjectNNavi');
	API_TV    = document.getElementById('pluginTV');
	
	pluginAPI  = new Common.API.Plugin();
	
	g_CONFIG.server    = 'http://media.idcompany.ru/samsung_tv/';
	g_CONFIG.MAC       = API_Net.GetHWaddr();
	g_CONFIG.DUID      = API_NNAVI.GetDUID( g_CONFIG.MAC );
	g_CONFIG.PROD_TYPE = API_TV.GetProductType();
	API_NNAVI.SetBannerState(2);	
	
	window.onshow = function(){
		pluginAPI.registKey(tvKey.KEY_CHLIST);
	}
	
	pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	pluginAPI.unregistKey(tvKey.KEY_MUTE);

	
	AppManager.setScene(Scene_Splash);
	$('#listener').focus();
	
	widgetAPI.sendReadyEvent();
}

AppManager.onunload = function()
{ 
    var plugin = 'pluginPlayer';
	plugin = document.getElementById(plugin); 
	if (plugin){
		plugin.Stop();
	}

}


AppManager.setLayout = function(name)
{
	var f = fs.openFile('html/'+name+'.html', 'r');
	var layout = f.readAll();
	insertHTML('app_content', layout);
	fs.closeFile(f);
}

AppManager.pingServer = function(successFunc, errorFunc)
{
	$.ajax({
		url: g_CONFIG.server+'ok.txt',
		success: successFunc,
		error: errorFunc,
		timeout: 10000
	});
}