Scene_Video = {}
Scene_Video.timeoutID = null;
Scene_Video.onSet = function()
{
	//обработчики для  модели
	var handlers = {
		
		bufStartHandler  : Scene_Video.onBufStart,
		bufCompleteHandler  : Scene_Video.onBufComplete,
		inetErrorHandler : Scene_Video.onInetError,
		networkDisconnectedHandler : Scene_Video.onNetworkDisconnected,
		streamNotFoundHandler : Scene_Video.onStreamNotFound,
		renderErrorHandler : Scene_Video.onRenderError,
		nextHandler : Scene_Video.onNext,
		prevHandler : Scene_Video.onPrev,
		videoProgressHandler : Scene_Video.onProgress,
		volumeChangeHandler  : View_Video.setVolume,
		muteChangeHandler    : View_Video.setMute,
		streamInfoReadyHandler: Scene_Video.onStreamInfoReady
	};
	
	Model_Video.setHandlers(handlers);	
	AppManager.setLayout('Video');	

	//загружаем список доступного видео
	View_Video.showPreloader();		//показываем прелоадер
	Model_Video.loadList(function(){

		//в случае успешной загрузки списка, инициалищируем слайдер превьюшек
		
		//параметры для слайдера
		var params = {
			images : Model_Video.getPreviewList(), 
			imgW : 516,
			imgH : 311,
			scrW : 960,
			margin : 40,
			handlers : {
				'onInited' : View_Video.hidePreloader,
				'onSwappingStart'  : View_Video.showPreloader,
				'onSwappingEnd'    : View_Video.hidePreloader,
				'onLoadingError'   : Scene_Video.onInetError
			}
		}
		
		//показываем хелпбар
		if (! Model_Video.last())
			View_Video.showButtonsVideo();	
		else
			View_Video.showButtonsToBuy();
		
		$('#slider').idcSlider('init', params); //инициализируем слайдер
		
		Model_Video.initAudio();
		
		if ((Model_Video.audioOut == Model_Video.AD_EXTERNAL) ||
			(Model_Video.audioOut == Model_Video.AD_RECEIVER) ||
			(g_CONFIG.PROD_TYPE == Model_Video.PROD_TYPE_BD))
		{
			View_Video.hideSoundControl();
		}
		else {
			
			View_Video.setVolume( Model_Video.audio.GetVolume() );
			View_Video.setMute( Model_Video.getMute() );
		}
		
		alert('video');
	});
}



Scene_Video.onUnSet = function()
{
	Model_Video.clear();
}

Scene_Video.onKeyDown = function()
{	
alert(event.keyCode);
	if (event.keyCode == tvKey.KEY_RETURN)
		widgetAPI.blockNavigation(event);
	
	if (event.keyCode == tvKey.KEY_EXIT)
		widgetAPI.blockNavigation(event);	
	//игнорим нажатие клавиш, если в данный момент анимируется превьюшка
	//или показан прелоадер
	if (View_Video.previewAnimated()) {alert('anim!');return};
	if (View_Video.preloader && (event.keyCode != tvKey.KEY_EXIT)) {
		alert('preloader!');
		return;
	};
	
	if (event.keyCode == tvKey.KEY_EXIT) {
		
		
		if (Model_Video.shownVideo && View_Video.preloader) return;
		
		if (Model_Video.shownVideo)
			Model_Video.stop();	
		
		widgetAPI.blockNavigation(event);
		widgetAPI.sendExitEvent();
		return;
	}
	
	//если нажали энтер во время того, как показано сообщение об ошибке - выходим в приложения
	if ( View_Message.shown && (event.keyCode == tvKey.KEY_ENTER) )
	{
		widgetAPI.sendReturnEvent();
		return;
	}
	
	if (Model_Video.shownVideo)
		Scene_Video.onKeyDownVideo();
	else
		Scene_Video.onKeyDownChoice();
}


Scene_Video.onKeyDownVideo = function()
{
	if (event.keyCode == tvKey.KEY_RETURN) {
		
		pluginAPI.setOnScreenSaver();
		Scene_Video.stop();
		return;
	}
	
	//если кнопки не показаны
	//то при нажатии на любую клавишу показываем их
	//и делаем пятисекундный settimeout на их скрытие

	if ((! View_Video.player) && (event.keyCode != tvKey.KEY_STOP)) {
		
		View_Video.showPlayer();
		Scene_Video.timeoutID = setTimeout(
			function(){
				View_Video.hidePlayer();
			},
			5000
		);			
	}
	else {
		//если кнопки показаны
		//удаляем старый settimeout и делаем новый
		clearTimeout(Scene_Video.timeoutID);
		Scene_Video.timeoutID = setTimeout(
			function(){
				View_Video.hidePlayer()
			},
			5000
		);
	}
	
		
	//свич по видеокнопкам
	switch (event.keyCode) {

		case tvKey.KEY_PLAY:
			if (Model_Video.shownVideo && (!Model_Video.pauseNow)) return;
			Scene_Video.play();
			break;
			
		case tvKey.KEY_STOP:	
			
			Scene_Video.stop();
			pluginAPI.setOnScreenSaver();
			break;
			
		case tvKey.KEY_PAUSE:
	
			pluginAPI.setOnScreenSaver();
			View_Video.pause();
			Model_Video.pause();
			break;
			
		case tvKey.KEY_FF:
			Model_Video.forward();
			break;
			
		case tvKey.KEY_RW:
			Model_Video.back();
			break;
			
		case tvKey.KEY_VOL_UP:
		case tvKey.KEY_PANEL_VOL_UP:
			if (Model_Video.shownVideo && Model_Video.audio) {
				if (Model_Video.getMute())
					Model_Video.muteChange();
				Model_Video.volumeUp();
			}
			break;
			
		case tvKey.KEY_VOL_DOWN:
		case tvKey.KEY_PANEL_VOL_DOWN:
			if (Model_Video.shownVideo && Model_Video.audio) {
				if (Model_Video.getMute())
					Model_Video.muteChange();
				Model_Video.volumeDown();
			}
			break;
			
		case tvKey.KEY_MUTE:
			Model_Video.muteChange(true);
			break;
	}
}


Scene_Video.onKeyDownChoice = function()
{
	switch (event.keyCode) {

		case tvKey.KEY_1:
			alert( Model_Video.getMute() );
			break;
		
		case tvKey.KEY_LEFT:
			
			if (View_Message.shown)     return;
			Model_Video.prev();
			break;
			
		case tvKey.KEY_RIGHT:
			
			if (View_Message.shown)     return;
			Model_Video.next();
			break;
			
		case tvKey.KEY_RETURN:
	
			if (View_Message.shown) 
				View_Message.hideMessage();
	
			AppManager.setScene(Scene_Main);
			break;

		case tvKey.KEY_EXIT:
			
			widgetAPI.blockNavigation(event);
			widgetAPI.sendExitEvent();
			break;
			
		case tvKey.KEY_ENTER:
			
			if (View_Message.shown)     return;
			
			if (! Model_Video.shownVideo) {
				if (! Model_Video.last()) {
					
					Scene_Video.play();
				}
				else {
					AppManager.setScene(Scene_Buy, {'prevScene':'video'});
				}	
			}
			
			break;
			
		case tvKey.KEY_PLAY:
			if (View_Message.shown)     return;
			
			if (! Model_Video.last()) {
				Scene_Video.play();
			}
			break;
	}	
}


Scene_Video.onInetError = function()
{
	$('#screen').css('display', 'block');
	View_Video.hidePreloader();
	View_Message.showMessage(View_Message.INET_ERROR, View_Video.buttonsError)
}

Scene_Video.onNext = function()
{
	$('#slider').idcSlider('next');
	if (Model_Video.last())
		View_Video.showButtonsToBuy();
}

Scene_Video.onPrev = function()
{
	$('#slider').idcSlider('prev');
	if (Model_Video.curVideoNum == Model_Video.videos.length-2)
		View_Video.showButtonsVideo();
}


//обработчики событий, связанных с видеоплеером

Scene_Video.onNetworkDisconnected = function()
{
	Scene_Video.stop();
	View_Video.hidePreloader();
	View_Message.showMessage(View_Message.INET_ERROR, View_Video.buttonsError);
}

Scene_Video.onStreamNotFound = function()
{
	Scene_Video.onNetworkDisconnected();
}

Scene_Video.onRenderError = function()
{
	Model_Video.stop();
	$('#screen').css('display', 'block');
	View_Video.hidePreloader();
	View_Message.showMessage(View_Message.RENDER_ERROR, View_Video.buttonsError);
}

Scene_Video.onBufStart = function()
{
	if (! Model_Video.shownVideo) return;
	alert('buf start');
	
	View_Video.showPreloader();
	var success = function(){}
	var error = Scene_Video.onNetworkDisconnected;
	AppManager.pingServer(success, error);
}

Scene_Video.onBufComplete = function()
{
	alert('buf end');
	View_Video.hidePreloader();
}


Scene_Video.play = function()
{
	View_Video.play();
	pluginAPI.setOffScreenSaver();
	if (Model_Video.pauseNow)
		Scene_Video.resume();
	else 
		Scene_Video.start();
}

Scene_Video.start = function()
{
	if (! Model_Video.player)
		Model_Video.createPlayer();

	//прежде чем начать проигрывать видео - проверяем связь с сервером
	View_Video.showPreloader();
	var success = function(){

		View_Video.startVideo();
		Model_Video.play();
	};
	
	var error = Model_Video.inetErrorHandler;	
	
	AppManager.pingServer(success, error);
}

Scene_Video.resume = function()
{
	//прежде чем начать проигрывать видео - проверяем связь с сервером
	View_Video.showPreloader();
	var success = function(){

		View_Video.hidePreloader();
		Model_Video.play();
	};
	
	var error = Model_Video.inetErrorHandler;	
	AppManager.pingServer(success, error);
}


Scene_Video.stop = function()
{	
	$('#video_controller').css('display', 'none');
	alert('STOP!');
	clearTimeout(Scene_Video.timeoutID);
	Model_Video.stop();
	
	$('#scene_video').css('display', 'block');
	$('#helpbar').css('display', 'block');
	View_Video.hidePlayer();
	//View_Video.showButtonsVideo();
	View_Video.stop();
}


Scene_Video.onProgress = function(cur, total)
{
	if ( (total-cur) < 1 ) {
		Scene_Video.stop();
		pluginAPI.setOnScreenSaver();
	}
	else {
		View_Video.setProgressBar(cur, total);
	}
}

Scene_Video.onStreamInfoReady = function(t)
{
	View_Video.setTotalTime(Model_Video.videoLength);
	View_Video.hidePreloader();
}