/**
 * Прототипный объект для плеера 
 */
ProtoPlayer = {};
ProtoPlayer.STATE_STOPPED = 0;
ProtoPlayer.STATE_PLAYING = 1;
ProtoPlayer.STATE_PAUSED  = 2;  
ProtoPlayer.STATE_FORWARD = 3;
ProtoPlayer.STATE_REWIND  = 4;

//замыкание для создания обработчика с указанным контекстом
ProtoPlayer.createHandler   = function(self, handler) {
	return function(){handler.call(self)};
}


function IDCPlayer(options) {
	
	//плагин DeviceAPI для плеера
	this.plugin = options.pluginID || 'pluginPlayer';
	this.plugin = document.getElementById(this.plugin);
	this.plugin.style.display = "block";

	this.state = this.STATE_STOPPED;
	this.screens = options.screens;
	
	//this.plugin.SetInitialTimeOut(25);
	
	this.playVideo = function(url) {
		
		alert(url);
		//this.plugin.style.display = "block";
		if (this.state == this.STATE_STOPPED) {
			
			this.state = this.STATE_PLAYING;
			this.plugin.Play(url);
		}
	}
	
	this.pauseVideo = function() {
		
		if (this.state == this.STATE_PLAYING) {
			
			this.state = this.STATE_PAUSED;
			this.plugin.Pause();
		}
	}
	
	this.stopVideo = function() {
		
		//this.plugin.style.display = "none";
		if (this.state != this.STATE_STOPPED) {
			
			this.state = this.STATE_STOPPED;
			this.plugin.Stop();
		}

	}
	
	this.resumeVideo = function() {
		
		if (this.state == this.STATE_PAUSED) {
			
			this.state = this.STATE_PLAYING;
			this.plugin.Resume();
		}
	}
	
	this.skipForwardVideo = function(h) {
		
		//this.resumeVideo();
		this.plugin.JumpForward(h);
	}
	
	this.skipBackwardVideo = function(h) {
		
		//this.resumeVideo();
		this.plugin.JumpBackward(h);
	}
	
	this.setHandler = function(eventName, handler) {
	
		this.plugin[eventName] = this.createHandler(this, handler); 
	}
	
	
	this.setScreen = function(screen) {
		if ( typeof(screen) == 'string' ) {
			
			var d = this.screens[ screen ];
			this.plugin.SetDisplayArea(d.x1, d.y1, d.x2, d.y2);
		}
		else {
			this.plugin.SetDisplayArea(screen.x1, screen.y1, screen.x2, screen.y2);
		}
		
		if (this.state == this.STATE_PAUSED) {
			this.state = this.STATE_PLAYING;
		}
	}
	
	this.setHandler = function(eventName, handler) {
		
		this.plugin[eventName] = handler;
	}
}


IDCPlayer.prototype = ProtoPlayer;