Model_Video = {}

Model_Video.H = 7;	//шаг перемотки

Model_Video.audio       = null;
Model_Video.audioOut    = null;

Model_Video.AD_EXTERNAL  = 3;
Model_Video.AD_RECEIVER  = 4;
Model_Video.PROD_TYPE_BD = 2;

Model_Video.player      = null;
Model_Video.shownVideo  = false;
Model_Video.pauseNow    = false;
Model_Video.videoLength = null;

Model_Video.videos      = null;
Model_Video.curVideoNum = null;

//возвращает список доступного видео. Нужно передать параметр duid - айдишник телевизора
Model_Video.SERVER_VIDEO     = 'http://media.idcompany.ru/samsung_tv/fixiki/get_video.php';

//возвращает список видео, доступного для покупки. Параметр duid аналогично
Model_Video.SERVER_VIDEO_BUY = 'http://media.idcompany.ru/samsung_tv/fixiki/get_video_buy.php';

//Покупка видео (заводит заказ и возвращает текст для смски). 
//Нужно два параметра: duid (айдишник телевизора) и vid (айдишник мультика)
Model_Video.SERVER_BUY       = 'http://media.idcompany.ru/samsung_tv/fixiki/get_sms.php';


Model_Video.getMute = function()
{
	return Model_Video.audio.GetUserMute();
}

Model_Video.getVolume = function()
{
	return Model_Video.audio.GetVolume();
}


Model_Video.initAudio = function()
{
	this.audio = document.getElementById("pluginAudio");
	this.audioOut = this.audio.GetOutputDevice();
	//this.audio.SetUserMute( Model_Video.mute ); 
	
}

Model_Video.setHandlers = function(handlers)
{
	for (var hName in handlers)
		Model_Video[hName] = handlers[hName];
}

Model_Video.clear = function()
{
	Model_Video.videos      = null;
	Model_Video.curVideoNum = null;
	Model_Video.stop();
}

Model_Video.loadList = function (callback)
{
	this.videos = {};
	this.videos.curVideoNum = 0;
	
	$.ajax({
		url:this.SERVER_VIDEO,
		context: this,
		data: {'duid': g_CONFIG.DUID},
		success:function(resp){
			
			Model_Video.videos = $.parseJSON(resp);
			
			Model_Video.videos.push({'img':'images/video_buy.png'});
			Model_Video.curVideoNum = 0;
			callback.call();
			
		},
		error:function(){
			Model_Video.inetErrorHandler.call();
		},
		timeout: 30000
	});
}

Model_Video.last = function()
{
	
	return (Model_Video.curVideoNum == Model_Video.videos.length-1);
}

Model_Video.getPreviewList = function()
{
	var result = [];
	for (var i=0; i < this.videos.length; i++)
		result.push(this.videos[i].img);
	
	return result;
}


Model_Video.loadBuyList = function(callback)
{
	this.videos = {};
	this.videos.curVideoNum = 0;
	
	$.ajax({
		url:this.SERVER_VIDEO_BUY,
		context: this,
		data:{'duid':g_CONFIG.DUID},
		success:function(resp){
			
			Model_Video.videos = $.parseJSON(resp);
			Model_Video.curVideoNum = 0;
			callback.call();
			
		},
		error:function(){
			Model_Video.inetErrorHandler.call();
		},
		timeout: 30000
	});
}

Model_Video.getImgURL = function()
{
	return this.videos[this.curVideoNum].img;
}

Model_Video.next = function()
{
	var cnt = this.videos.length;
	if ( this.curVideoNum < cnt-1 ) {
		
		this.curVideoNum++;
		this.nextHandler.call();
	}
}

Model_Video.prev = function()
{
	if ( this.curVideoNum > 0 ) {
		
		this.curVideoNum--;
		this.prevHandler.call();
	}
}

Model_Video.createPlayer = function()
{
	var playerOptions ={
	pluginID: 'pluginPlayer',
		screens : {
			full : {x1 : 0, y1:0, x2: 960, y2: 540},
			small : {x1 : 0, y1:0, x2: 960, y2: 540}
			//small : {x1 : 217, y1:32, x2: 543, y2: 316}
		}
	}	

	this.player = new IDCPlayer(playerOptions);	
	
	this.player.plugin.OnBufferingStart    = 'Model_Video.bufStartHandler';
	this.player.plugin.OnBufferingComplete = 'Model_Video.bufCompleteHandler';
	this.player.plugin.OnNetworkDisconnected  = 'Model_Video.networkDisconnectedHandler';
	this.player.plugin.OnConnectionFailed  = 'Model_Video.networkDisconnectedHandler';
	this.player.plugin.OnRenderError  = 'Model_Video.renderErrorHandler';
	this.player.plugin.OnStreamNotFound  = 'Model_Video.streamNotFoundHandler';
	this.player.plugin.OnStreamInfoReady = 'Model_Video.setTotalTime';
	this.player.plugin.OnCurrentPlayTime = 'Model_Video.videoProgress';
	
	this.player.setScreen('full');
}


Model_Video.play = function()
{

	if (Model_Video.player.state == Model_Video.player.STATE_STOPPED) {
		
		this.player.setScreen('full');
		Model_Video.shownVideo = true;	
		Model_Video.player.playVideo( Model_Video.videos[Model_Video.curVideoNum].video );
	}
		
	else if (Model_Video.player.state == Model_Video.player.STATE_PAUSED) {
		
		Model_Video.player.resumeVideo();
	}
	this.pauseNow = false;
}

Model_Video.pause = function()
{
	this.player.pauseVideo();
	this.pauseNow = true;
}

Model_Video.stop = function()
{
	if (this.player)
		this.player.stopVideo();
	this.shownVideo = false;
	this.videoLength = null;
	this.pauseNow = false;
}

Model_Video.forward = function()
{
	this.player.skipForwardVideo(Model_Video.H);
}

Model_Video.back = function()
{
	this.player.skipBackwardVideo(Model_Video.H);
}

Model_Video.setTotalTime = function()
{
	Model_Video.videoLength = Model_Video.player.plugin.GetDuration();
	Model_Video.streamInfoReadyHandler.call();
}

Model_Video.videoProgress = function(time)
{	
	Model_Video.videoProgressHandler.call(null, time, Model_Video.videoLength);
}

Model_Video.volumeUp = function()
{
	if ((Model_Video.audioOut == Model_Video.AD_EXTERNAL) ||
		(g_CONFIG.PROD_TYPE == Model_Video.PROD_TYPE_BD) ) {
	
		return;
	}
	else {
		Model_Video.audio.SetVolumeWithKey(0);
		if (Model_Video.audioOut == Model_Video.AD_RECEIVER) {
			return;
		}
		else {
			Model_Video.volumeChangeHandler.call(null, Model_Video.audio.GetVolume());
		}
	}
	
}

Model_Video.volumeDown = function()
{
	if ((Model_Video.audioOut == Model_Video.AD_EXTERNAL) ||
		(g_CONFIG.PROD_TYPE == Model_Video.PROD_TYPE_BD) ) {
	
		return;
	}
	else {
		Model_Video.audio.SetVolumeWithKey(1);
		if (Model_Video.audioOut == Model_Video.AD_RECEIVER) {
			return;
		}
		else {
			Model_Video.volumeChangeHandler.call(null, Model_Video.audio.GetVolume());
		}
		
		if ( (Model_Video.getVolume() == 0) && (! Model_Video.getMute()) )
			Model_Video.muteChange();
	}
	
}

Model_Video.muteChange = function(lock)
{
	
	
	if ((Model_Video.audioOut == Model_Video.AD_EXTERNAL) ||
		(g_CONFIG.PROD_TYPE == Model_Video.PROD_TYPE_BD) ) {
	
		return;
	}
	else {
		
		if ( (Model_Video.getVolume() == 0) && (Model_Video.getMute() && (lock)) )
			return;
		
		//Model_Video.mute = ! Model_Video.mute;
		var mute = Model_Video.getMute()==0 ? 1 : 0;
		this.audio.SetUserMute( mute ); 
		if (Model_Video.audioOut == Model_Video.AD_RECEIVER) {
			return;
		}
		else {
			Model_Video.muteChangeHandler.call(null, Model_Video.getMute());
		}
	}	
	
}


Model_Video.buy = function()
{
	$.ajax({
		url: Model_Video.SERVER_BUY,
		success: function(resp){
			Model_Video.buyHandler.call(null, resp);
		},
		error: Model_Video.inetErrorHandler,
		timeout: 20000,
		type: 'GET',
		data: {duid: g_CONFIG.DUID, vid: Model_Video.videos[Model_Video.curVideoNum].id}
	});
}

